`default_nettype none
module div2(clkout, div2en, fs128, firclock, reset);
input wire div2en, fs128, firclock, reset;
// all must be synchronous to firclock, including fs128
output reg clkout;
reg fs128d, div2ens, up128fsd;
wire up128fs;
assign up128fs = fs128 && (!fs128d);
always @ (posedge firclock)
begin
	fs128d <= fs128;
	up128fsd <= up128fs;
	if (reset)
	begin
		clkout <= 1'b0;
		div2ens <= 1'b1;
	end
	else
	begin
		if (up128fs)
			div2ens <= div2en;
		else
			div2ens <= div2ens;
		case ({div2ens, up128fsd})
		2'b00: clkout <= fs128d;
		2'b01: clkout <= fs128d;
		2'b10: clkout <= clkout;
		2'b11: clkout <= !clkout;
		endcase
	end
end
endmodule
`default_nettype wire
