module fscounter(firclock, lrclock, firreset, fsgt90kHz, fsgt100kHz, fsgt190kHz);
// Aangepast aan 189 MHz firclock, adjusted to 189 MHz firclock
input firclock, lrclock, firreset;
output reg fsgt90kHz;
output reg fsgt100kHz;
output reg fsgt190kHz;
reg [15:0] counter;
reg lrclocksynch1, lrclocksynch2, lrclockold;
always @ (posedge firclock) // firclock: 189 MHz = 7 * 27 MHz
begin
	lrclocksynch1 <= lrclock;
	lrclocksynch2 <= lrclocksynch1;
	lrclockold <= lrclocksynch2;
	if (firreset)
	begin
		fsgt90kHz <= 1'b1;
		fsgt100kHz <= 1'b1;
		fsgt190kHz <= 1'b0;
		// Het filter dat gebruikt wordt als 100 kHz < fs < 190 kHz werkt
		// altijd, dus neem 100 kHz < fs < 190 kHz maar als resetwaarde.
		// The filter that is used when 100 kHz < fs < 190 kHz always
		// works, so let's take 100 kHz < fs < 190 kHz as reset value.
		counter <= 16'b0;
	end
	else
	begin
		if (lrclocksynch2 && (!lrclockold))
		begin
			if (fsgt90kHz)
				fsgt90kHz <= (counter < 16'd2100); // 90 kHz
			else
				fsgt90kHz <= (counter < 16'd2077); // 90,99662975 kHz
			if (fsgt100kHz)
				fsgt100kHz <= (counter < 16'd1909); // 99,00471451 kHz
			else
				fsgt100kHz <= (counter < 16'd1890); // 100 kHz
			if (fsgt190kHz)
				fsgt190kHz <= (counter < 16'd995); // 189,9497487 kHz
			else
				fsgt190kHz <= (counter < 16'd990); // 190,9090909... kHz
			counter <= 16'b0;
		end
		else
			counter <= (counter + 16'b1) % 65536;
	end
end
endmodule
