`default_nettype none
module i2s(dout, lrout, data, bck, lrck);
input wire data, bck, lrck;
output reg[31:0] dout;
output reg lrout;
reg [4:0] bitnr;
reg[31:0] dpar;
reg lr1, lr2;
always @ (posedge bck)
begin
	lr1 <= lrck;
	lr2 <= lr1;
	if (lr1 ^ lr2)
	begin
		dout <= dpar;
		lrout <= lr2;
		dpar[30:0] <= 31'b0;
		dpar[31] <= data;
		bitnr <= 5'b11111;
	end
	else
	begin
		if (bitnr != 5'b00000)
		begin
			dpar[bitnr-1] <= data;
			bitnr <= bitnr - 5'b00001;
		end
	end
end
endmodule
`default_nettype wire
