`default_nettype none
module i2smux(data, lrck, bck, sel4192, data4192, lrck4192, bck4192, datai2s, lrcki2s, bcki2s, firclock, firreset, silent);
// Hopelijk veilige multiplexer voor de bitklok, hopefully safe multiplexer for the bit clock
input wire sel4192, data4192, lrck4192, datai2s, lrcki2s, firclock, firreset;
(* CLOCK_SIGNAL = "TRUE" *) input wire bck4192;
(* CLOCK_SIGNAL = "TRUE" *) input wire bcki2s;
output reg data, lrck, silent;
(* CLOCK_SIGNAL = "TRUE" *) output reg bck;
reg [10:0] waitcounter;
(* ASYNC_REG = "TRUE" *) reg [1:0] sel4192synch;
(* ASYNC_REG = "TRUE" *) reg [2:0] bck4192synch;
(* ASYNC_REG = "TRUE" *) reg [2:0] bcki2ssynch;
(* ASYNC_REG = "TRUE" *) reg [2:0] bcksynch;
reg bck4192down, bcki2sdown, en4192, eni2s;
always @ (posedge firclock)
begin
	sel4192synch[1:0] <= {sel4192synch[0], sel4192};
	bck4192synch[2:0] <= {bck4192synch[1:0], bck4192};
	bcki2ssynch[2:0] <= {bcki2ssynch[1:0], bcki2s};
	bcksynch[2:0] <= {bcksynch[1:0], bck};
	if (firreset)
	begin
		en4192 <= 1'b0;
		eni2s <= 1'b0;
		waitcounter <= 11'b0;
	end
	else
	begin
		if (bck4192down || (silent && (!sel4192synch[1]))) en4192 <= sel4192synch[1] && (!eni2s);
		if (bcki2sdown || (silent && sel4192synch[1])) eni2s <= (!sel4192synch[1]) && (!en4192);
		if (bcksynch[2] ^ bcksynch[1]) waitcounter <= 11'b0;
		else
		begin
			if (!silent) waitcounter <= waitcounter + 11'b1;
			else waitcounter <= waitcounter;
		end
	end
end
always @ (*)
begin
	bck4192down = (!bck4192synch[1]) && bck4192synch[2];
	bcki2sdown = (!bcki2ssynch[1]) && bcki2ssynch[2];
	silent = waitcounter[10] && waitcounter[6]; // 1088 firclockperioden wachten, wait 1088 firclock periods
	bck = (en4192 && bck4192) || (eni2s && bcki2s);
	data = (en4192 && data4192) || (eni2s && datai2s);
	lrck = (en4192 && lrck4192) || (eni2s && lrcki2s);
end
endmodule
`default_nettype wire
