module interpol3(sdclock, firclock, bck4392, lrck4392, reset, data4392, filter_sel, ditherl1, ditherr1, doutl, doutr, fclip);
// Simplified version of interpol that only interpolates by three and then applies a zeroth-order hold.
	parameter wordlengthfirint3out = 58;
	parameter wordlengthout = 35;
	input sdclock, reset, data4392;
	input [1:0] filter_sel;
	// filter_sel[0] -> correctie voor analoog filter, correction for analogue filter
	// filter_sel[1] -> 50 us/15 us deemfase, 50 us/15 us deemphasis
	input signed [32:0] ditherl1; // overbodige bits laten we hier wel doodlopen
	input signed [32:0] ditherr1; // overbodige bits laten we hier wel doodlopen
	// Unnecessary dither bits are left unconnected at this hierarchical level.
	output reg signed [wordlengthout-1:0] doutl;
	output reg signed [wordlengthout-1:0] doutr;
	output firclock, lrck4392, fclip;
//	(* KEEP = "TRUE" *) output wire bck4392; ##!!##
	output wire bck4392;
	reg fclip3l, fclip3r, fclip5l, fclip5r;
	reg longreset;
	reg longresetfir;
	reg resetack;
	reg [52:0] sipo;
	reg signed [23:0] links;
	reg signed [23:0] rechts;
	reg signed [32:0] ditherl1synch;
	reg signed [32:0] ditherr1synch;
	wire signed [wordlengthfirint3out-1:0] links3;
	wire signed [wordlengthfirint3out-1:0] rechts3;
	wire signed [wordlengthout-1:0] doutlfifo;
	wire signed [wordlengthout-1:0] doutrfifo;
	reg signed [wordlengthfirint3out-1:0] l3d;
	reg signed [wordlengthfirint3out-1:0] r3d;
	reg signed [wordlengthout-1:0] din2l;
	reg signed [wordlengthout-1:0] din2r;
	reg aap, noot, mies;
	reg nd1, nd2l, nd2r, resets1, resetsynchsd, startfiforead, rd_en, rd_en_d1, rd_en_d2;
	reg [6:0] tel45;
	reg [5:0] tel54;
	wire rdy1l, rdy1r, rdy2l, rdy2r, prog_emptyr, prog_emptyl, fulll, fullr, emptyl, emptyr; 
	wire rfd1l, rfd1r, rfd2l, rfd2r;
	reg signed [wordlengthout-1:0] fiforin;
	reg signed [wordlengthout-1:0] fifolin;
	reg rdy2ld, rdy2rd;
	wire CLK0, CLK180, CLK270, CLK2X, CLK2X180, CLK90, CLKDV, firclock180, LOCKED, PSDONE, CLKFB;
	wire [7:0] STATUS;
	//klokken maken, making clocks
	DCM_SP #(.CLKDV_DIVIDE(2.5), //Afgedeelde uitgang is gerelateerd aan fin
		.CLKFX_DIVIDE(1),
		.CLKFX_MULTIPLY(7),
		.CLKIN_DIVIDE_BY_2("FALSE"),
		.CLKIN_PERIOD(37.037),
		.CLKOUT_PHASE_SHIFT("FIXED"),
		.CLK_FEEDBACK("1X"), //????
		.DESKEW_ADJUST("SYSTEM_SYNCHRONOUS"), //????
		.DFS_FREQUENCY_MODE("LOW"),
		.DLL_FREQUENCY_MODE("LOW"),
		.DSS_MODE("NONE"),
		.DUTY_CYCLE_CORRECTION("TRUE"),
		.FACTORY_JF(16'hc080),
		.PHASE_SHIFT(0), // 0/256 times input clock period
		.STARTUP_WAIT("FALSE"))
		DCM_SP_inst (CLK0, CLK180, CLK270, CLK2X, CLK2X180, CLK90, CLKDV, firclock, firclock180, LOCKED, PSDONE, STATUS, CLK0, sdclock, 1'b0, 1'b0, 1'b0, 1'b0, reset);
		// CLKFB op CLK0 aansluiten is eigenlijk niet eens nodig als je alleen CLKFX maar gebruikt.
		// Connecting CLKFB to CLK0 is actually not even needed when you only use CLKFX.

		// Gebruik sdreset, hij mag pas losgelaten worden
		// als de 27 MHz-klok ingeregeld is!
		// Use the sdreset and only release it after the 27 MHz
		// clock is properly settled!

		reg locked_long, locked_synch1, locked_synch2;
		always @ (posedge firclock or negedge LOCKED)
			if (~LOCKED)
			begin
				locked_long <= 1'b0;
				locked_synch1 <= 1'b0;
				locked_synch2 <= 1'b0;
			end
			else
			begin
				locked_synch1 <= LOCKED;
				locked_synch2 <= locked_synch1;
				locked_long <= locked_synch2;
			end

	always @ (posedge CLKDV or posedge reset) // of toch firclock?
	begin
		if (reset)
			longreset <= 1'b1;
		else
		begin
			if (~ locked_long)
				longreset <= 1'b1;
			else
				longreset <= longreset & (~resetack);
		end
	end
	// Je moet er rekening mee houden dat resetack onbepaald is
	// zolang er geen firclock is! Vandaar het gedoe met locked_long.
	// Keep in mind that resetack is undefined as long as there is
	// no firclock! Hence the use of locked_long.

	always @ (posedge firclock or posedge longreset)
	begin
		if (longreset)
			longresetfir <= 1'b1;
		else
			longresetfir <= longreset;
	end
	// Volstaat dit of moet je gaan prutsen met asynchrone registers?
	// Does this suffice or do you have to start messing around with asynchronous registers?
	
	always @ (negedge CLKDV) //##!!
	begin
		if (longreset)
		begin
			tel54 <= 6'b000101;
			resetack <= 1'b1;
			// Verlengde reset nodig, want firclock 
			// begint pas nadat gewone reset is afgelopen!
			// Longer reset needed, because firclock
			// starts when the normal reset is gone!
		end
		else
		begin
			resetack <= 1'b0;
			if (tel54 == 6'b111010)
			begin
				tel54 <= 6'b000101;
				rechts <= sipo[25:2];
				links <= sipo[52:29];
			end
			else
				tel54 <= tel54+1;
		end
	end

	// assign bck4392 = CLKDV;
	// ODDR2 geplaatst en gebruikt als buffer, zoals aanbevolen door
	// Xilinx (Clock Forwarding technique)
	// ODDR2 instantiated and used as buffer, as recommended by Xilinx
	// (Clock Forwarding technique)
	ODDR2 #(
		.DDR_ALIGNMENT("NONE"),
		.INIT(1'b0),
		.SRTYPE("SYNC")
	) ODDR2_inst (
		.Q(bck4392),
		.C0(CLKDV),
		.C1(!CLKDV),
		.CE(1'b1),
		.D0(1'b1),
		.D1(1'b0),
		.R(1'b0),
		.S(1'b0)
	);

	
	assign lrck4392 = tel54[5];
	always @ (posedge CLKDV)
		sipo[52:0] <= {sipo[51:0],data4392};
	always @ (posedge CLKDV or posedge longreset)
	begin
		if (longreset)
			aap <= 1'b0;
		else
			aap <= lrck4392;
	end
	always @ (posedge firclock)
	begin
		noot <= aap;
		mies <= noot;
	end
	always @ *
		nd1 = (~noot) & mies;
	firint3 firl (
	.sclr(longresetfir), // input sclr
	.clk(firclock), // input clk
	.nd(nd1), // input nd
	.filter_sel(filter_sel), // input [1 : 0] filter_sel
	.rfd(rfd1l), // output rfd
	.rdy(rdy1l), // output rdy
	.din(links), // input [23 : 0] din
	.dout(links3)); // output [57 : 0] dout
	firint3 firr (
	.sclr(longresetfir), // input sclr
	.clk(firclock), // input clk
	.nd(nd1), // input nd
	.filter_sel(filter_sel), // input [1 : 0] filter_sel
	.rfd(rfd1r), // output rfd
	.rdy(rdy1r), // output rdy
	.din(rechts), // input [23 : 0] din
	.dout(rechts3)); // output [57 : 0] dout
	always @ (posedge firclock)
	begin
		ditherl1synch <= ditherl1;
		ditherr1synch <= ditherr1;
	end

// Pijpleidingerij, pipe lining:
	reg rdy1lp, rdy1rp;
	always @ (posedge firclock)
	begin
		r3d <= rechts3 + $signed(ditherr1synch[32:32-wordlengthfirint3out+wordlengthout]);
		l3d <= links3 + $signed(ditherl1synch[32:32-wordlengthfirint3out+wordlengthout]);
		rdy1lp <= rdy1l;
		rdy1rp <= rdy1r;
	end

	always @ (posedge firclock)
	begin
		case (l3d[wordlengthfirint3out-1:wordlengthfirint3out-3])
			3'b111:
			begin
				fclip3l <= 0;
				din2l[wordlengthout-1:0] <= l3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthout-2];
			end
			3'b000:
			begin
				fclip3l <= 0;
				din2l[wordlengthout-1:0] <= l3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthout-2];
			end
			default:
			begin
				fclip3l <= 1;
				// din2l <= din2l;
			end
		endcase
		nd2l <= rdy1lp;
		case (r3d[wordlengthfirint3out-1:wordlengthfirint3out-3])
			3'b111:
			begin
				fclip3r <= 0;
				din2r[wordlengthout-1:0] <= r3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthout-2];
			end
			3'b000:
			begin
				fclip3r <= 0;
				din2r[wordlengthout-1:0] <= r3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthout-2];
			end
			default:
			begin
				fclip3r <= 1;
				// din2r <= din2r; // Vorige monster herhalen
				// bij oversturing, repeat previous sample
				// when clipping.
			end
		endcase
		nd2r <= rdy1rp;
	end
	fifo64 fifol (
  	.rst(longresetfir), // input rst
  	.wr_clk(firclock), // input wr_clk
  	.rd_clk(sdclock), // input rd_clk
  	.din(din2l), // input [34 : 0] din
  	.wr_en(nd2l), // input wr_en
  	.rd_en(rd_en), // input rd_en
  	.dout(doutlfifo), // output [34 : 0] dout
  	.full(fulll), // output full
  	.empty(emptyl), // output empty
  	.prog_empty(prog_emptyl) // output prog_empty
	);	
	fifo64 fifor (
  	.rst(longresetfir), // input rst
  	.wr_clk(firclock), // input wr_clk
  	.rd_clk(sdclock), // input rd_clk
  	.din(din2r), // input [34 : 0] din
  	.wr_en(nd2r), // input wr_en
  	.rd_en(rd_en), // input rd_en
  	.dout(doutrfifo), // output [34 : 0] dout
  	.full(fullr), // output full
  	.empty(emptyr), // output empty
  	.prog_empty(prog_emptyr) // output prog_empty
	);
	always @ (posedge sdclock)
	begin
		if (resetsynchsd)
			tel45 <= 7'b0010100;
		else
		begin
			if (tel45[6])
				tel45 <= 7'b0010100;
			else
				tel45 <= tel45 + 7'b0000001;
		end
		resets1 <= reset;
		resetsynchsd <= resets1;
		startfiforead <= (~resetsynchsd) & (startfiforead|(~(prog_emptyl|prog_emptyr)));
		// Ervoor zorgen dat de FIFO-uitgangen alleen bemonsterd worden als ze in een gedefinieerde toestand zijn,
		// dus vooral niet tijdens de "read latency".
		// making sure the FIFO outputs only get sampled when they are in a defined state, so certainly not
		// during the read latency.
		rd_en_d1 <= rd_en;
		rd_en_d2 <= rd_en_d1;
		if (rd_en_d2)
		begin
			doutl <= doutlfifo;
			doutr <= doutrfifo;
		end
	end
	always @ *
		rd_en = tel45[6] & startfiforead;
	assign fclip = fclip3l || fclip3r;
endmodule
