`default_nettype none
module pll128(fs128, locked, firclock, lrin, reset);
input wire firclock, lrin, reset;
output wire fs128;
output wire locked;
reg [5:0] locked_int;
reg signed [16:0] feedbackcounter;
reg signed [16:0] feedbackcounterold;
reg signed [16:0] phaseintegrator;
reg [17:0] ratemult;
reg [15:0] fcw;
reg fs128old;
wire signed [16:0] diff;
// wire [16:0] blaat;
reg [16:0] blaat;
(* ASYNC_REG = "TRUE" *) reg lrs1;
(* ASYNC_REG = "TRUE" *) reg lrs2;
reg lrs3;
wire lrup;
assign diff = phaseintegrator - feedbackcounter;
// assign blaat = (feedbackcounter - feedbackcounterold) % 131072;
// assign blaat = feedbackcounter - feedbackcounterold;
assign lrup = lrs2 && (!lrs3);
always @ (posedge firclock)
begin
	blaat <= feedbackcounter - feedbackcounterold; // geen idee of dit werkt, maar haalt het de timing?
	if (reset)
	begin
		lrs1 <= 1'b0;
		lrs2 <= 1'b0;
		lrs3 <= 1'b0;
		feedbackcounter <= 17'sb0;
		phaseintegrator <= 17'sb0;
		ratemult <= 18'b0;
		fs128old <= 1'b0;
		locked_int <= 6'b0;
//		fcw <= 17'sd6851; // 216 MHz * 6851/2**18 ~= 128 * 44.1 kHz
		fcw <= 16'd7829; // 189 MHz * 7829/2**18 ~= 128 * 44.1 kHz
		feedbackcounterold <= 17'sb0;
	end
	else
	begin
		lrs3 <= lrs2;
		lrs2 <= lrs1;
		lrs1 <= lrin;
		if (lrup)
		begin
			phaseintegrator <= phaseintegrator + 17'sd128; // may overflow, but that's intended
			if (diff < 0)
				fcw <= 16'd0;
			else
				fcw <= diff[15:0];
			if (phaseintegrator[8:7]==2'b11)
			begin
				if ((blaat < 514) && (blaat > 510)) // considered locked when momentary frequency is within 0.2 %
				begin
					if (locked_int[5] == 1'b0)
						locked_int <= locked_int + 6'b000001;
					else
						locked_int <= locked_int;
				end
				else
					locked_int <= 6'b000000;
				feedbackcounterold <= feedbackcounter;
			end
			else
			begin
				locked_int <= locked_int;
				feedbackcounterold <= feedbackcounterold;
			end
		end
		else
		begin
			phaseintegrator <= phaseintegrator;
			fcw <= fcw;
			locked_int <= locked_int;
			feedbackcounterold <= feedbackcounterold;
		end
		if ((!fs128old) && ratemult[17])
			feedbackcounter <= feedbackcounter + 1; // may overflow, but that's intended
		else
			feedbackcounter <= feedbackcounter;
		fs128old <= ratemult[17];
		ratemult <= (ratemult + fcw) % 262144;
	end
end
assign fs128 = ratemult[17];
assign locked = locked_int[5];
endmodule
`default_nettype wire
