`default_nettype none
module prefilter(reset, bck, lrck, data, firclock, sel, dither, sel4192, dsdon, dsd64_128, bckout, lrckout, dataout);
// sel[2:0] = 3'b0XX: niet filteren, alleen verzwakken
// sel[2:0] = 3'b100: twee keer interpolatie
// sel[2:0] = 3'b101: DSD-filter
// sel[2:0] = 3'b110: temperen ofte apodiseren
// sel[2:0] = 3'b111: transitieband versmallen zonder interpolatie
// 
// sel[2:0] = 3'b0XX: don't filter, just attenuate
// sel[2:0] = 3'b100: two times interpolation
// sel[2:0] = 3'b101: DSD filter
// sel[2:0] = 3'b110: apodize
// sel[2:0] = 3'b111: narrow the transition band without interpolation
//
// sel[2:0] moet synchroon zijn met firclock, anders gaat het opwekken van
// sclr5...sclr7 fout.
// sel[2:0] must be synchronized to firclock, otherwise generating
// sclr5...sclr7 goes wrong.
//
input wire reset, bck, lrck, data, firclock;
input wire [2:0] sel;
input wire signed [64:0] dither;
input wire sel4192, dsdon, dsd64_128;
output wire bckout, dataout;
output reg lrckout;
wire bckreset, bckresi;
wire bckoutn;
reg [64:0] dithers;
wire signed [31:0] din;
reg lrcksynch, datasynch, lr3, lr5, l1, d1;
(* ASYNC_REG = "TRUE" *) reg d2;
(* ASYNC_REG = "TRUE" *) reg d3;
(* ASYNC_REG = "TRUE" *) reg l2;
(* ASYNC_REG = "TRUE" *) reg l3;
(* ASYNC_REG = "TRUE" *) reg b1;
(* ASYNC_REG = "TRUE" *) reg bcksynch;
(* ASYNC_REG = "TRUE" *) reg lr4;
(* ASYNC_REG = "TRUE" *) reg lrckds;
wire lr2;
reg lrup, lrdown, sclr4, sclr5, sclr6, sclr7, rd_en, zus;
wire nd4, nd6, nd7;
reg hulp;
reg nd5tpf, nd5;
(* ASYNC_REG = "TRUE"*) reg nd5tpfo;
(* ASYNC_REG = "TRUE"*) reg nd5tpfo2;
reg nd5tpfo3;
reg nd5dop;
reg [4:0] dsdcounter;
wire signed [64:0] dout4;
wire signed [38:0] dout5l;
wire signed [38:0] dout5r;
wire signed [64:0] dout6;
wire signed [65:0] dout7;
reg [67:0] inmux0;
reg [67:0] inmux4;
reg [67:0] inmux5;
reg [67:0] inmux6;
reg [67:0] inmux7;
reg [67:0] muxout;
wire [66:0] fifodout;
reg [65:0] fifodoutd1;
reg [23:0] fifodoutdit;
wire rdy4, rdy5l, rdy5r, rdy6, rdy7, chan_out4, chan_out6, chan_out7;
reg rdy5ld;
wire chan_in4, chan_in6, chan_in7;
wire rfd4, rfd5l, rfd5r, rfd6, rfd7;
reg [2:0] sel_old;
reg [4:0] readcounter;
reg fifowaitff, resetfiltsw;
wire resetfiltsw1, resetfiltsw2;
reg dataoutt;
reg tiehigh, pisopl1, pisopl2, pisopl3;
reg [30:0] piso;  //parallel in, serieel uit voor I2S naar SRC4392 parallel in, serial out for I2S to SRC4392
(* ASYNC_REG = "TRUE" *) reg [15:0] dopregl;
reg [15:0] pisodopl; //schuifregisters voor DoP
(* ASYNC_REG = "TRUE" *) reg [15:0] pisodopr; //shift registers for DoP
wire full, empty, prog_empty;
wire lock128;
wire fs128;
reg fs128oud;
reg fs32;
reg [1:0] fs32count;
reg lrpll;
reg [4:0] count1632;
(* ASYNC_REG = "TRUE" *) reg hulpa;
(* ASYNC_REG = "TRUE" *) reg div2en;
wire dsd128reset, dsd128resets1, dsd128resets2;
wire signed [5:0] d128flout;
wire signed [5:0] d128frout;
reg signed [5:0] datadsdl;
reg signed [5:0] datadsdr;
reg bckd2;
(* ASYNC_REG = "TRUE" *) reg bckd2s1;
(* ASYNC_REG = "TRUE" *) reg bckd2s2;
reg dopl, dopr;
(* ASYNC_REG = "TRUE"*) reg [2:0] dsdon_old;
(* ASYNC_REG = "TRUE"*) reg [2:0] dsd64_128_old;
reg sel4192_old;

// verlengen reset tot bitklok er is
// lengthen reset until bitclock is there
(* ASYNC_REG = "TRUE" *)
FDPE ffbckreset1(bckresi, bck, tiehigh, reset, reset); //Q, C, CE, PRE, D
(* ASYNC_REG = "TRUE" *)
FDPE ffbckreset2(bckreset, bck, tiehigh, bckresi, bckresi); //Q, C, CE, PRE, D
// afdelen bitklok voor de ruwe DSD-interface, omdat die geen woordklok heeft
// dividing off the bitclock for the raw DSD interface, because it has no wordclock
always @ (posedge bck)
begin
	if (bckreset || sel4192 || (!dsdon)) count1632 <= 5'b0;
	else
	begin
		if (dsd64_128)
			count1632 <= count1632 + 5'b00001;
		else
			count1632 <= count1632 + 5'b00010;
	end
end
// selecteren van de woordklok of de afgedeelde bitklok
// selecting either the wordclock or the divided bitclock
always @ (*)
begin
	if (dsdon && (!sel4192)) lrpll = count1632[4];
	else lrpll = lrck;
end
// PLL die de bitklok (of het dubbele daarvan) maakt voor de interface naar de SRC4392
// PLL that makes the bitclock (or twice that) for the interface to the SRC4392
pll128 pll128a(fs128, lock128, firclock, lrpll, reset);
div2 bckoutdiv(bckoutn, div2en, fs128, firclock, reset);

// Klok op fs128/4 voor de DoP-DSD-interface, synchroon met firclock,
// enkele firclock-puls breed
// Clock at fs128/4 for the DoP DSD interface, synchronous to firclock,
// single firclock pulse wide
always @ (posedge firclock)
begin
	fs128oud <= fs128;
	if (reset)
		fs32count <= 2'b0;
	else
	begin
		if (fs128 && (!fs128oud))
		begin
			if (fs32count == 2'b11) fs32 <= 1'b1;
			fs32count <= (fs32count + 2'b1) % 4;
		end
		else fs32 <= 1'b0;
	end
end	

always @ (*) hulp = (~sel[2]) | sel[1] | sel[0] | (dsdon & (~sel4192));
// hulp = 1 als er geen dubbele klok nodig is
// hulp = 1 when there is no doubled clock needed
always @ (posedge firclock)
begin
	hulpa <= hulp;
	div2en <= hulpa;
end

assign dsd128reset = (!dsdon) | sel4192 | (!dsd64_128) | reset;
// Flip-flops met asynchrone set om dsd128reset te synchroniseren met de bitklok:
// Flip-flops with asynchronous preset to synchronize dsd128reset to the bitclock:
(* ASYNC_REG = "TRUE" *)
FDPE ffdsd128reset1(dsd128resets1, bck, tiehigh, dsd128reset, dsd128reset); //Q, C, CE, PRE, D
(* ASYNC_REG = "TRUE" *)
FDPE ffdsd128reset2(dsd128resets2, bck, tiehigh, dsd128resets1, dsd128resets1); //Q, C, CE, PRE, D
dsd128fir dsdl128fir(d128flout, data, bck, bckd2, dsd128resets2);
dsd128fir dsdr128fir(d128frout, lrck, bck, bckd2, dsd128resets2);
always @ (posedge bck)
begin
	if (dsd128resets2) bckd2 <= 1'b0;
	else bckd2 <= !bckd2;
end
always @ (posedge firclock)
begin
	bckd2s1 <= bckd2;
	bckd2s2 <= bckd2s1;
end

always @ (*)
begin
	case ({sel4192, dsdon, dsd64_128})
		3'b011:
		begin 
			datadsdl = d128flout;
			datadsdr = d128frout;
			nd5tpf = bckd2s2;
		end
		3'b010:
		begin
			datadsdl = {!datasynch, 5'b10000};
			datadsdr = {!lrcksynch, 5'b10000};
			nd5tpf = bcksynch;
		end
		default:
		begin
			datadsdl = {!dopl, 5'b10000};
			datadsdr = {!dopr, 5'b10000};
			nd5tpf = nd5dop;
		end
	endcase
end
always @ (posedge firclock)
begin
	nd5tpfo <= nd5tpf;
	nd5tpfo2 <= nd5tpfo;
	nd5tpfo3 <= nd5tpfo2;
end
always @ (*) nd5 = nd5tpfo2 && (!nd5tpfo3);

i2s i2sin(din, lr2, data, bck, lrck);
always @ (posedge bck)
begin
	lr3 <= lr2;
	l1 <= lrck;
	d1 <= data;
end
always @ (posedge firclock)
begin
	lr4 <= lr3;
	lrckds <= lr4;
	lr5 <= lrckds;
	d2 <= d1;
	d3 <= d2;
	datasynch <= d3;
	l2 <= l1;
	l3 <= l2;
	lrcksynch <= l3;
	b1 <= bck;
	bcksynch <= b1;
end
always @ *
begin
	lrup = lrckds & (~lr5);
	lrdown = lr5 & (~lrckds);
end

always @ (posedge firclock)
begin
	if (lrdown) dopregl <= din[24:8];
	if (lrup)
	begin
		dsdcounter <= 5'b00000;
		pisodopl <= dopregl;
		pisodopr <= din[24:8];
		nd5dop <= 1'b0;
	end
	else
	begin
		if (fs32 && (!dsdcounter[4]))
		begin
			dsdcounter <= dsdcounter + 5'b00001;
			dopl <= pisodopl[15];
			dopr <= pisodopr[15];
			pisodopl[15:0] <= {pisodopl[14:0], 1'b0};
			pisodopr[15:0] <= {pisodopr[14:0], 1'b0};
			nd5dop <= 1'b1;
		end
		else nd5dop <= 1'b0;
	end
end

firdsd6 firdsdl (
	.sclr(sclr5), // input sclr
	.clk(firclock), // input clk
	.nd(nd5), // input nd
	.rfd(rfd5l), // output rfd
	.rdy(rdy5l), // output rdy
	.din(datadsdl), // input [5 : 0] din
	.dout(dout5l)); // output [38 : 0] dout
firdsd6 firdsdr (
	.sclr(sclr5), // input sclr
	.clk(firclock), // input clk
	.nd(nd5), // input nd
	.rfd(rfd5r), // output rfd
	.rdy(rdy5r), // output rdy
	.din(datadsdr), // input [5 : 0] din
	.dout(dout5r)); // output [38 : 0] dout
// DSD-filters, 6 bit in, 39 bit uit, 14 keer decimerend,
// Wilkinson N = 256, p = 3, tau = 0, stopband vanaf 0,03239285714 fs.
//
// DSD filters, 6 bit in, 39 bit out, 14 times decimating,
// Wilkinson N = 256, p = 3, tau = 0, stop band from 0.03239285714 fs.
//
assign nd4 = (chan_in4 ? lrup : lrdown) && (!sclr4);
fir384interpol2 fir384interpol2lr (
	.sclr(sclr4), // input sclr
	.clk(firclock), // input clk
	.nd(nd4), // input nd
	.rfd(rfd4), // output rfd
	.rdy(rdy4), // output rdy
	.chan_in(chan_in4), // output [0 : 0] chan_in
	.chan_out(chan_out4), // output [0 : 0] chan_out
	.din(din), // input [31 : 0] din
	.dout(dout4)); // output [64 : 0] dout
// twee keer interpolerend filter, interpoleert
// met een macht van twee en hoeft dus niet geschaald te worden.
//
// two times interpolating filter, interpolates with a power of two and,
// hence, need not be scaled.
//
assign nd6 = (chan_in6 ? lrup: lrdown) && (!sclr6);
fir40 fir40lr (
	.sclr(sclr6), // input sclr
	.clk(firclock), // input clk
	.nd(nd6), // input nd
	.rfd(rfd6), // output rfd
	.rdy(rdy6), // output rdy
	.chan_in(chan_in6), // output [0 : 0] chan_in
	.chan_out(chan_out6), // output [0 : 0] chan_out
	.din(din), // input [31 : 0] din
	.dout(dout6)); // output [64 : 0] dout
// temper- ofte apodiseringsfilter
// Uitgangssignaal moet een bitje verschoven worden ten opzichte van de
// ruigere filters vanwege het beperkte doorschot.
//
// apodizing filter, output signal must be shifted a bit compared to the
// steeper filters because the apodizing filter has much less overshoot.
//
assign nd7 = (chan_in7 ? lrup : lrdown) && (!sclr7);
fir512 fir512lr (
	.sclr(sclr7), // input sclr
	.clk(firclock), // input clk
	.nd(nd7), // input nd
	.rfd(rfd7), // output rfd
	.rdy(rdy7), // output rdy
	.chan_in(chan_in7), // output [0 : 0] chan_in
	.chan_out(chan_out7), // output [0 : 0] chan_out
	.din(din), // input [31 : 0] din
	.dout(dout7)); // output [65 : 0] dout
// steil niet-interpolerend filter
// steep non-interpolating filter
always @ (posedge firclock) rdy5ld <= rdy5l;
always @ *
begin
	inmux0 = {(lrup|lrdown), lrckds, din[31], din[31], din[31:0], 32'b0};
	inmux4 = {rdy4, chan_out4, dout4[64:0], 1'b0};
	zus = rdy5l|rdy5ld;
	if (rdy5l)
		inmux5 = {zus, (~rdy5l), dout5l[38], dout5l[36:0], 28'b0};
	else
		inmux5 = {zus, (~rdy5l), dout5r[38], dout5r[36:0], 28'b0};
// Dit kan zelfs met uitsturing van 0 % tot 100 % enen niet tot oversturing leiden, want het ingangssignaal van het DSD-filter komt niet verder dan
// 6'sb010000 danwel 6'sb110000 (en de som van de absolute waarden van de coefficienten gedeeld door de som van de coefficienten is maar 1,3164968...).
// Voor DSD met uitsturing van 25 % tot 75 % enen (conform het Scarlet Book) klopt de geluidssterkte nu met die van PCM.
// This cannot lead to overflow, not even when the DSD stream is modulated all the way from 0 % ones to 100 % ones, because the input signal of the
// DSD filter cannot go beyond 6'sb010000 and 6'sb110000 (and the sum of the absolute values of the coefficients divided by the sum of the coefficients
// is only 1.3164968...). For DSD modulated from 25 % ones to 75 % ones (as specified in the Scarlet Book), the volume now matches that of PCM.
	inmux6 = {rdy6, chan_out6, dout6[64], dout6[64:0]};
	inmux7 = {rdy7, chan_out7, dout7[65:0]};
	case (sel[2:0])
		3'b100: muxout = inmux4;
		3'b101: muxout = inmux5;
		3'b110: muxout = inmux6;
		3'b111: muxout = inmux7;
		default: muxout = inmux0;
	endcase
end
fifo16_67 fifo (
  .rst(resetfiltsw), // input rst
  .wr_clk(firclock), // input wr_clk
  .rd_clk(bckoutn), // input rd_clk
  .din(muxout[66:0]), // input [66 : 0] din
  .wr_en(muxout[67] && (!full)), // input wr_en
  .rd_en(rd_en && (!empty)), // input rd_en
  .dout(fifodout), // output [66 : 0] dout
  .full(full), // output full
  .empty(empty), // output empty
  .prog_empty(prog_empty) // output prog_empty
);
always @ *
begin
	fifodoutd1[65:0] = $signed(fifodout[65:0]) + $signed(dithers[64:22]);
	fifodoutdit = $signed(fifodoutd1[65:42]);
end
always @ (posedge firclock)
begin
	case (sel[2:0]) // case statement used to be in an always @ * block, put here as pipelining
		3'b100:
		begin
			sclr4 <= reset;
			sclr5 <= 1'b1;
			sclr6 <= 1'b1;
			sclr7 <= 1'b1;
		end
		3'b101:
		begin
			sclr4 <= 1'b1;
			sclr5 <= reset;
			sclr6 <= 1'b1;
			sclr7 <= 1'b1;
		end
		3'b110:
		begin
			sclr4 <= 1'b1;
			sclr5 <= 1'b1;
			sclr6 <= reset;
			sclr7 <= 1'b1;
		end
		3'b111:
		begin
			sclr4 <= 1'b1;
			sclr5 <= 1'b1;
			sclr6 <= 1'b1;
			sclr7 <= reset;
		end
		default:
		begin
			sclr4 <= 1'b1;
			sclr5 <= 1'b1;
			sclr6 <= 1'b1;
			sclr7 <= 1'b1;
		end
	endcase
	sel_old[2:0] <= sel[2:0];
	dsdon_old[2:0] <= {dsdon_old[1:0], dsdon};
	dsd64_128_old[2:0] <= {dsd64_128_old[1:0], dsd64_128};
	sel4192_old <= sel4192;
end

reg resetfiltswonverlengd;
reg [4:0] resetfiltswverlenger;

always @ *
begin
	resetfiltswonverlengd = (~lock128)|reset|(sel_old[2]^sel[2])|(sel_old[1]^sel[1])|(sel_old[0]^sel[0])|(sel4192_old^sel4192)|(dsd64_128_old[2]^dsd64_128_old[1])|(dsdon_old[2]^dsdon_old[1]);
	tiehigh = 1'b1;
	resetfiltsw = !resetfiltswverlenger[4];	
end

always @ (posedge firclock)
begin
	if (resetfiltswonverlengd)
		resetfiltswverlenger <= 5'b00000;
	else
	begin
		if (!resetfiltswverlenger[4]) resetfiltswverlenger <= resetfiltswverlenger + 5'b00001;
	end
end

(* ASYNC_REG = "TRUE" *)
FDPE ffasynchset1(resetfiltsw1, bckoutn, tiehigh, resetfiltsw, resetfiltsw); //Q, C, CE, PRE, D
(* ASYNC_REG = "TRUE" *)
FDPE ffasynchset2(resetfiltsw2, bckoutn, tiehigh, resetfiltsw, resetfiltsw1); //Q, C, CE, PRE, D
always @ (posedge bckoutn)
begin
	fifowaitff <= (~resetfiltsw2) & ((~prog_empty)|fifowaitff);
	if (resetfiltsw2|rd_en|(~fifowaitff))
		readcounter <= 5'b00000;
	else
		readcounter <= readcounter + 5'b00001;
end
always @ * rd_en = readcounter[4] & readcounter[3] & readcounter[1] & readcounter[0] & (readcounter[2]|(sel[2] & (~sel[1]) & sel[0]));
always @ (posedge bckoutn)
begin
	dithers <= dither; //pijpleidingerij, pipelining
	pisopl1 <= rd_en;
	pisopl2 <= pisopl1;
	pisopl3 <= pisopl2;
	if (pisopl2) lrckout <= fifodout[66];
	if (pisopl3)
	begin
		dataoutt <= fifodoutdit[23];
		piso[30:0] <= {fifodoutdit[22:0], 8'b00000000};
	end
	else
	begin
		dataoutt <= piso[30];
		piso[30:0] <= {piso[29:0], 1'b0};
	end
end

assign bckout = !bckoutn;
assign dataout = dataoutt;
endmodule
`default_nettype wire
